#!/bin/bash
set -x
set -e
set -o pipefail

NMSG="nmsg-0.6.12"
WRECK="wreck-0.1.10"
SIE_NMSG="sie-nmsg-0.6"

NMSG_URL="ftp://ftp.isc.org/isc/nmsg/$NMSG.tar.gz"
WRECK_URL="ftp://ftp.isc.org/isc/nmsg/$WRECK.tar.gz"
SIE_NMSG_URL="ftp://ftp.isc.org/isc/nmsg/misc/$SIE_NMSG.tar.gz"

###
### no user modifiable content below
###

PROTOBUF="protobuf-2.3.0"
PROTOBUF_C="protobuf-c-0.14"

PROTOBUF_URL="http://protobuf.googlecode.com/files/$PROTOBUF.tar.gz"
PROTOBUF_C_URL="http://protobuf-c.googlecode.com/files/$PROTOBUF_C.tar.gz"

BUILDDIR="$(mktemp -d)"

echo '/usr/local/lib64' > /etc/ld.so.conf.d/usr_local_lib64.conf

for URL in "$NMSG_URL" "$WRECK_URL" "$SIE_NMSG_URL" "$PROTOBUF_URL" "$PROTOBUF_C_URL"; do
    wget -P "$BUILDDIR" "$URL"
done

tar -C "$BUILDDIR" -zxf "$BUILDDIR"/"$(basename $WRECK_URL)"
cd "$BUILDDIR/$WRECK" && ./configure --prefix=/usr/local --libdir=/usr/local/lib64
make -C "$BUILDDIR/$WRECK" install
ldconfig

tar -C "$BUILDDIR" -zxf "$BUILDDIR"/"$(basename $PROTOBUF_URL)"
cd "$BUILDDIR/$PROTOBUF" && ./configure --prefix=/usr/local --libdir=/usr/local/lib64
make -C "$BUILDDIR/$PROTOBUF" install
ldconfig

tar -C "$BUILDDIR" -zxf "$BUILDDIR"/"$(basename $PROTOBUF_C_URL)"
cd "$BUILDDIR/$PROTOBUF_C" && ./configure --prefix=/usr/local --libdir=/usr/local/lib64
make -C "$BUILDDIR/$PROTOBUF_C" install
ldconfig

tar -C "$BUILDDIR" -zxf "$BUILDDIR"/"$(basename $NMSG_URL)"
cd "$BUILDDIR/$NMSG" && ./configure --prefix=/usr/local --libdir=/usr/local/lib64 --sysconfdir=/etc --with-plugindir=/usr/local/lib64/nmsg
make -C "$BUILDDIR/$NMSG" install
ldconfig

tar -C "$BUILDDIR" -zxf "$BUILDDIR"/"$(basename $SIE_NMSG_URL)"
cd "$BUILDDIR/$SIE_NMSG" && ./configure --prefix=/usr/local --libdir=/usr/local/lib64
make -C "$BUILDDIR/$SIE_NMSG" install
